//---------------------------------------------------------------------------
//
//   WiredSelectable
//
//          Copyright(C) 2015, Tark
//
//     IʂC[
//
//---------------------------------------------------------------------------

#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#include "MQPlugin.h"
#include "CMQObject.h"
#include "WiredSelectable.h"

//---------------------------------------------------------------------------
//  MQGetPlugInID
//---------------------------------------------------------------------------
void WiredSelectable::GetPlugInID(DWORD *Product, DWORD *ID)
{
	*Product = 0xE3F7A830;
	*ID = 0xBD9A188D;
}

//---------------------------------------------------------------------------
//  MQGetPlugInName
//---------------------------------------------------------------------------
const char *WiredSelectable::GetPlugInName(void)
{
	// vOC
	return "WiredSelectable ver.1.0 Copyright(C) 2017, Tark.";
}

//---------------------------------------------------------------------------
//  MQEnumString
//---------------------------------------------------------------------------
const char *WiredSelectable::EnumString(int index)
{
	switch (index) {
	case 0: return "WiredSelectable"; break;
	}
	return NULL;
}

MQBasePlugin *GetPluginClass()
{
	static WiredSelectable plugin;
	return &plugin;
}

BOOL WiredSelectable::Execute(int index, MQDocument doc_)
{
	doc = cmq::CMQDocument(doc_);
	switch (index) {
	case 0:
		return main(index);
	}
	return FALSE;
}

WiredSelectable::WiredSelectable() : doc(nullptr)
{
}

WiredSelectable::~WiredSelectable()
{
}

BOOL WiredSelectable::main(int index)
{
	cmq::CMQObject cur = doc.getCurrentObject();

	bool selected = false;

	// ӂLʂ̐
	std::unordered_map<cmq::CMQLindex, int> line_shared;
	// 폜
	std::vector<cmq::findex_t> face_to_delete;

	// eʂɂďӂmapɓo^
	// IĂȂʂł΃JEgAbvAIĂʂł΍폜\Ȃ̂ŃJEgȂ
	// ʁAmapɂ͖ʍ폜ɋLʂ̐Ă͂
	cmq::CMQContainer<cmq::CMQFace, cmq::CMQObject> fcontainer(&cur);
	for (auto fit = fcontainer.begin(); fit != fcontainer.end(); ++fit) {
		if (fit->isSelect()) {
			face_to_delete.push_back(fit.index());
			selected = true;
		}
		std::vector<cmq::vindex_t> varray(5);
		cur.getFacePointArray(fit.index(), varray);
		for (int i = 0; i < varray.size(); i++) {
			cmq::CMQLindex line(varray[i], varray[NEXTIDX(i, varray.size())]);
			auto findit = line_shared.find(line);
			int n = 0;
			if (findit == line_shared.end()) {
				line_shared.insert(std::make_pair(line, fit->isSelect() ? 0 : 1));
			}
			else {
				if (!fit->isSelect()) {
					findit->second++;
				}
			}
		}
	}
	if (!selected) {
		// IʂȂꍇ͉Ȃ
		return FALSE;
	}

	// Iʂ̍폜ɋLʂȂȂӂ̓C쐬Ă
	for (auto it : line_shared) {
		if (it.second == 0) {
			auto fpair = it.first;
			std::vector<cmq::vindex_t> varray({ fpair.v1(), fpair.v2() });
			cur.addFace(varray);
		}
	}

	// ʂ폜
	for (auto findex : face_to_delete) {
		cur.deleteFace(findex);
	}
	return TRUE;
}
